/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 03 - solution 3
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdlib.h>
#include <stdio.h>

#define N 5

void aeiou (char *, char [], int [], int, int, int);

int main (int argc, char **argv) {
  char *sol;
  char alfa[N] = {'A','E','I','O','U'};
  int taken[N] = {0};
  int n_char;

  if (argc<2) {
    fprintf (stderr, "Run as: pgrm numberOfChar.\n");
    exit(EXIT_FAILURE);
  }
  n_char = atoi(argv[1]);
  if (n_char<N) {
    fprintf (stderr, "Run with: numberOfChars > N (%d<%d).\n", n_char, N);
    exit(EXIT_FAILURE);
  }

  sol = malloc (n_char * sizeof(char));
  if (sol==NULL) {
    fprintf (stderr, "Memory allocation error.\n");
    exit(EXIT_FAILURE);
  }
  aeiou (sol, alfa, taken, 0, n_char-N, n_char);
  free (sol);

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
