/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 07 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <string.h>

int string_search (char *str, int *start, int *length) {
  int i, j;

  *start = *length = i = 0;
  // Visit string str
  while (i<strlen(str)-1) {
    j=i+1;
    // Visit sub-string starting at position i
    while (j<strlen(str) && str[j]==str[i]) {
      j++;
    }
    // Update best sub-string found
    if ((j-i) > (*length)) {
      *length = j-i;
      *start = i;
      i = j;
    } else {
      i = i+1;
    }
  }

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
