/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 09 - solution 2
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include "impl2.h"

static void levelByLevel_visit_r (struct node *, int, int);

void levelByLevel_visit (struct node *root, int l1, int l2) {
  int i;
 
  for (i=l1; i<=l2; i++) {
    fprintf (stdout, "Level %d: ", i);
    levelByLevel_visit_r (root, i, 1);
    fprintf (stdout, "\n");
  }

  return;
}

static void levelByLevel_visit_r (struct node *root, int level, int l) {
  int i;

  if (root==NULL)
    return;

  if (l == level) {
    fprintf (stdout, "%d ", root->key);
    return; 
  }

  for (i=0; i<N; i++) {
    levelByLevel_visit_r (root->child[i], level, l+1);
  }
  return;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
