/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 01 - solution 3
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

#include <stdlib.h>
#include <float.h>
#include <stdio.h>

#define N 10

void permute(int [], float [], float [], float *, float [], float *, float *,
  int, int);

int main(int argc, char **argv) {
  // Bank account cash flows
  float mov[N] = {1, -2, 3, 14, -5, 16, 7, 8, -9, 120};
  float sol[N] = {0};          // Current solution
  float best_sol[N] = {0};     // Best solution
  float best_diff = FLT_MAX;   // Smeller difference between max and min
  float min, max;
  int i;
  int taken[N] = {0};

  permute (taken, sol, best_sol, &best_diff, mov, &min, &max, 0, N);

  fprintf (stdout, "Best order: ");
  for (i=0; i<N; i++) {
    fprintf (stdout, "%.1f ", best_sol[i]);
  }
  fprintf (stdout, "\n");
  fprintf (stdout, "Max balance: %.1f\n", max);
  fprintf (stdout, "Min balance: %.1f\n", min);
  fprintf (stdout, "Min difference: %.1f\n", best_diff);

  return 0;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
