/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 * chapter 01 - exercise 11 - solution 1
 *
 * Nessuna garanzia viene fornita su questo programma:
 * gli Autori e la Casa Editrice non potranno in nessun
 * caso essere ritenuti responsabili di eventuali danni
 * (materiali e/o immateriali) da esso cagionati.
 * E' liberamente consentita la modifica (ma non la
 * redistribuzione) di questo file, a patto che le note
 * di copyright poste in testa e in coda a esso vengano
 * mantenute inalterate.
 * 
 */

void sequence_invert (int *v1, int n, int *v2) {
  int i, f, j;

  for (i=0, f=1; f<n; f++) {
    if (v1[f] <= v1[f-1]) {
      // End of sequence: Copy it in reverse order into v2
      for (j=0; j<(f-i); j++) {
        v2[i+j] = v1[f-j-1];
      }
      i = f;
    }
  }
  // Deal with last sub-sequence
  for (j=0; j<(f-i); j++) {
    v2[i+j] = v1[f-j-1];
  }

  return;
}

/*
 * Copyright C.L.U.T. - Torino - Ottobre 2018
 *
 * Stefano Quer
 * Advanced Programming and Problem-Solving Strategies in C
 * Part IV: Exam-Based Problems
 *
 */
